SystemOrganization addCategory: #'Mason-Examples'!

MDProduct subclass: #MDDistProduct
	instanceVariableNames: 'package version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Examples'!

!MDDistProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:43'!
build: anArray
	^ (self version: anArray) build! !

!MDDistProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:43'!
version: anArray
	^ self basicNew initializeWithVersion: anArray! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:35'!
archiveName
	^ String streamContents:
		[:out |
		out nextPutAll: self releaseName.
		out nextPut: $-.
		(version first: 3)
			do: [:number | out print: number]
			separatedBy: [out nextPut: $.].
		out nextPutAll: '.sar']! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 10:25'!
initVersion: anArray for: aClassName on: out 
	out
		nextPutAll: aClassName;
		nextPutAll: ' currentVersion: ';
		print: anArray;
		nextPut: $.! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:37'!
initializeWithVersion: anArray
	version := anArray! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:32'!
installerContent
	self subclassResponsibility! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:32'!
readMeContents
	self subclassResponsibility! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:34'!
repository
	^MCHttpRepository
		location: 'http://source.wiresong.ca/mc'
		user: ''
		password: ''	! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:38'!
specifyOn: targets 
	targets zip
		name: self archiveName;
		with: 
			[self specifyContentsOn: targets.
			targets file
				name: 'README';
				content: self readMeContents.
			targets directory
				name: 'install';
				with: 
					[targets file
						name: 'preamble';
						content: self installerContent]]! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 10:01'!
writeOpenReadmeOn: out 
	^ out
		nextPutAll: 'self openTextFile: ''README''.';
		cr! !

MDDistProduct subclass: #MDFilesystemDistProduct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Examples'!

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:58'!
infoClassName
	^ 'FSReleaseInfo'! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:37'!
initializeWithVersion: anArray 
	super initializeWithVersion: anArray.
	package := MDMc1LatestProduct new
		packageName: 'Filesystem';
		repository: self repository;
		yourself.
! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 10:25'!
installerContent
	| memberName |
	memberName := FSPath * package latestVersion last withExtension: 'st'.
	^ String streamContents: 
		[ :out | 
		out
			nextPutAll: 'self fileInMemberNamed: ';
			nextPut: $';
			print: memberName;
			nextPut: $';
			nextPut: $.;
			cr.
		self initVersion: version for: 'FSReleaseInfo' on: out.
		out cr.
		self writeOpenReadmeOn: out ]! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2009 13:37'!
readMeContents
	^ 'This is the first release of Filesystem, an alternate interface for dealing with files and directories. The interface offers: 
	- Convient path manipulation
	- Transparent access to the contents of zip files
	- Late-bound references to files and directories
	- Robust support for working with entire directory trees
	
More information about how to use the Filesystem API is available at the following URL:

http://www.wiresong.ca/filesystem/

'! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:33'!
releaseName
	^ 'Filesystem'! !

!MDFilesystemDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:38'!
specifyContentsOn: targets 
	package specifyOn: targets! !

MDDistProduct subclass: #MDMasonDistProduct
	instanceVariableNames: 'umbrella'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Examples'!

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:05'!
fileIn: name on: out
	out 
		nextPutAll: 'self fileInMemberNamed: ''';
		nextPutAll: name;
		nextPutAll: '.st''.'! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:40'!
initializeWithVersion: anArray
	super initializeWithVersion: anArray.
	umbrella := MDUmbrellaProduct new
		repository: self repository;
		packageName: 'Mason-Umbrella';
		dependencyPackageNames: self packageNames;
		yourself! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 10:54'!
installerContent
	| names filesystem mason |
	names := umbrella customizedVersionNames.
	filesystem := names detect: [ :ea | ea beginsWith: 'Filesystem' ].
	mason := names reject: [ :ea | ea beginsWith: 'Filesystem' ].
	^ String streamContents: 
		[ :out | 
		self on: out ifFilesystem: 
			[self fileIn: filesystem on: out.
			out cr; tab.
			self 
				initVersion: FSReleaseInfo current version
				for: 'FSReleaseInfo'
				on: out].
		out cr.
		mason do: 
			[ :name | 
			self fileIn: name on: out.
			out cr ].
		out cr.
		self initVersion: version for: 'MDMasonReleaseInfo' on: out.
		out cr.
		self writeOpenReadmeOn: out]! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 10:39'!
on: out ifFilesystem: aBlock 
	out
		nextPutAll: '(Smalltalk hasClassNamed: ''FSReleaseInfo'') ifFalse: ';
		cr; tab;
		nextPut: $[.
	aBlock value.
	out 
		nextPut: $];
		nextPut: $.;
		cr! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:19'!
packageNames
	^ #('Filesystem' 'Mason-Core' 'Mason-MC1' 'Mason-Metacello' 'Mason-Examples')! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:47'!
readMeContents
	^ 'This is Mason, a build system for Squeak. 
	
Mason is capable of building images that do not include Mason its self. This relies on OSProcess which is available at the following URL: 

	http://wiki.squeak.org/squeak/708
	
'! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:42'!
releaseName
	^ 'Mason'! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:44'!
specifyContentsOn: targets
	targets specify: umbrella.! !
